#!/usr/bin/env python

import pandas


def parse_data():
    frame = pandas.read_csv('timings.csv', header=None, names=('exec', 'kernel', 'what', 'value'), delimiter=' ')
    time = frame[frame.what == "time"]
    ops = frame[frame.what != "time"]

    # Here we should take 'min', but right now there are some zeroes written
    timedata = time.groupby(('exec', 'kernel'))['value'].min()
    opsdata = ops.groupby(('exec', 'kernel'))['value'].max()

    return timedata, opsdata


def calculate_floprate():
    time, ops = parse_data()

    for key in time.keys():
        exe, kernel = key
        if "nonopcount" in exe and kernel != "total":
            opexe = exe.replace("nonopcount", "opcount")
            print("exe={}".format(exe))
            print("opexe={}".format(opexe))
            print("kernel={}".format(kernel))
            print("FLOPS={}\n".format(ops[opexe][kernel] / time[exe][kernel]))


if __name__ == '__main__':
    calculate_floprate()
